#!/usr/bin/env python3
"""
    Copyright 2020 Hendrik Weimer

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
"""

import http.server
import socketserver

class myHTTPRequestHandler(http.server.BaseHTTPRequestHandler):

    def do_GET(self):

        path = self.path

        if path.endswith("/"):
            path = path + "index.html"

        # Beware of untrusted content resulting in directory traversal attacks!

        try:
            f = open("./" + path, "rb")
        except FileNotFoundError:
            self.send_response(404)
            return
        except:
            self.send_resonse(500)
            return

        buf = f.read()
        f.close()

        self.send_response(200)

        if path.endswith(".wasm"):
            self.send_header("Content-Type", "application/wasm")
        elif path.endswith(".js"):
            self.send_header("Content-Type", "application/javascript")
        elif path.endswith(".data"):
            self.send_header("Content-Type", "application/octet-stream")
        else:
            self.send_header("Cache-Control", "no-cache")
            self.send_header("Content-Type", "text/html")

        self.end_headers()

        self.wfile.write(buf)
        

port = 8080
handler = myHTTPRequestHandler

httpd = socketserver.TCPServer(('localhost', port), handler)
httpd.serve_forever()
